#!/usr/bin/env python
# coding:utf-8

import RPi.GPIO as GPIO
import os
import spidev #for MCP3008
from time import sleep

spi = spidev.SpiDev()
spi.open(0,0)
spi.max_speed_hz = 1000000

LL = 26 #left_led_num
CL = 16 #center_led_num
RL = 12 #right_led_num

LS = 13 #left_sw_num
CS = 6 #center_sw_num
RS = 5 #right_sw_num

LF = 14 #left_foot_num

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)

GPIO.setup(LL,GPIO.OUT)
GPIO.setup(CL,GPIO.OUT)
GPIO.setup(RL,GPIO.OUT)

GPIO.setup(LS,GPIO.IN)
GPIO.setup(CS,GPIO.IN)
GPIO.setup(RS,GPIO.IN)
GPIO.setup(LF,GPIO.IN)

fx_p = [0,1,2,3,4,5,6,7,8,9,10]
prefxp =[0,1,2,3,4,5]
mode = 0 #0 for ON/OFF, 1 for A/B
SD = 0 #10 for shutdown

def swL(channel):
    if fx_p[4] == 1:
        GPIO.output(LL, 0)
        sleep(0.2)
        GPIO.output(LL, 1)
        os.system("echo '0;' |  pdsend 3001") #adjust_vol

def swC(channel):
    global fx_p
    fx_p[2] = fx_p[2] + 1
    if fx_p[2] > 1:
        fx_p[2] = 0
        os.system("echo '0;' |  pdsend 3002") #A(0)
        GPIO.output(CL, 1)
        GPIO.output(RL, 0)
    else:
        fx_p[2] = 1
        os.system("echo '1;' |  pdsend 3002") #B(1)
        GPIO.output(RL, 1)
        GPIO.output(CL, 0)

def swR(channel):
    global SD
    SD = 0
    while GPIO.input(RS) == 0:
        GPIO.output(RL, 1)
        sleep(0.1)
        GPIO.output(RL, 0)
        sleep(0.1)
        SD = SD + 1
        if SD == 10:
            sleep(1)
            break

def footL(channel):
    global fx_p
    global mode #0 for ON/OFF, 1 for A/B
    #print str(GPIO.input(LF))
    if GPIO.input(LF)==0:
        mdf = 0 #1 for not changing ON/OFF or A/B
        MC = 0
        while GPIO.input(LF) == 0:
            sleep(0.02)
            MC = MC + 1
            if MC == 100:
                mode = mode + 1
                mdf = 1
                if mode > 1:
                    mode = 0 #ON/OFF
                    GPIO.output(LL, 1)
                else:
                    mode = 1 #A/B
                    fx_p[4] = 1
                    os.system("echo '1;' |  pdsend 3004") #ON
                break
        if mode == 0 and mdf == 0:
            fx_p[4] = fx_p[4] + 1
            if fx_p[4] > 1:
                fx_p[4] = 0
                os.system("echo '0;' |  pdsend 3004") #OFF
                GPIO.output(LL, 0)
            else:
                fx_p[4] = 1
                os.system("echo '1;' |  pdsend 3004") #ON
                GPIO.output(LL, 1)
        elif mode == 1 and mdf == 0:
            swC(0)

def readAdc(channel):
    adc = spi.xfer2([1,(8+channel)<<4,0])
    data = ((adc[1]&3) << 8) + adc[2]
    pm = (data * 1000) / 1023
    return pm

#main
os.system("pd main4_pd.pd &")
GPIO.output(LL, 1)
sleep(0.2)
GPIO.output(CL, 1)
sleep(0.2)
GPIO.output(RL, 1)
sleep(0.2)
GPIO.output(RL, 0)
sleep(0.2)
GPIO.output(CL, 0)
sleep(0.2)
GPIO.output(LL, 0)
sleep(0.5)

GPIO.add_event_detect(LS,GPIO.FALLING,callback=swL,bouncetime=300)
GPIO.add_event_detect(CS,GPIO.FALLING,callback=swC,bouncetime=300)
GPIO.add_event_detect(RS,GPIO.FALLING,callback=swR,bouncetime=300)
GPIO.add_event_detect(LF,GPIO.FALLING,callback=footL,bouncetime=300)

fx_p[0] = 0 #not used
fx_p[1] = 0 #not used left_sw:pdsend3001 adjust_vol
fx_p[2] = 0 #center_sw:3002 change A(0), B(1)
os.system("echo '0;' |  pdsend 3002")
GPIO.output(CL, 1)
fx_p[3] = 0 #not used right_sw:3003 save&shutdown
fx_p[4] = 0 #footsw 3004 fx_on_off change_mode
os.system("echo '0;' |  pdsend 3004")
fx_p[5] = readAdc(0) * 0.1 #pot0 pdsend3005
fx_p[6] = readAdc(1) * 0.1 #pot1 3006
fx_p[7] = readAdc(2) * 0.1 #pot2 3007
fx_p[8] = readAdc(3) * 0.1 #pot3 3008
fx_p[9] = readAdc(4) * 0.1 #pot4 3009
fx_p[10]= readAdc(5) * 0.1 #pot5 3010
beat = 0 #for blinking left led

try:
    while SD < 10:
        sleep(0.2)
        if mode == 1:
            btt = [0,0,1,1]
            beat = beat + 1
            if beat > 3:
                beat = 0
            GPIO.output(LL, btt[beat])
        for channel in range(6):
            p = channel + 5
            prefxp[channel] = fx_p[p]
            fx_p[p] = readAdc(channel) * 0.1
            dif = abs(prefxp[channel] - fx_p[p])
            if (dif > 0.9):
                #print("fx_p["+str(p)+"]:"+str(fx_p[p]))
                os.system("echo '"+ str(fx_p[p]) +";' |  pdsend 30"+ str(p).zfill(2))
    os.system("echo '0;' |  pdsend 3003") # SD==10, save&shutdown
    GPIO.output(LL, 1)
    GPIO.output(CL, 1)
    GPIO.output(RL, 1)
    sleep(1)
    spi.close()
    GPIO.cleanup()
    print "shutdown"
    os.system("sudo shutdown -h now")
except:
    pass
finally:
    spi.close()
    GPIO.cleanup()
